﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

using System.Web.Services;
using System.Configuration;
using System.Data.SqlClient;

public partial class CS : System.Web.UI.Page
{
    [WebMethod]
    public static string[] GetCountries(string prefix, int parentId)
    {
        SqlCommand cmd = new SqlCommand();
        string query = "SELECT CountryId, CountryName FROM Countries WHERE CountryName LIKE @Prefix + '%'";
        cmd.Parameters.AddWithValue("@Prefix", prefix);
        cmd.CommandText = query;
        return PopulateAutoComplete(cmd);
    }

    [WebMethod]
    public static string[] GetStates(string prefix, int parentId)
    {
        SqlCommand cmd = new SqlCommand();
        string query = "SELECT StateId, StateName FROM States WHERE StateName LIKE @Prefix + '%' AND CountryId=@CountryId";
        cmd.Parameters.AddWithValue("@Prefix", prefix);
        cmd.Parameters.AddWithValue("@CountryId", parentId);
        cmd.CommandText = query;
        return PopulateAutoComplete(cmd);
    }

    [WebMethod]
    public static string[] GetCities(string prefix, int parentId)
    {
        SqlCommand cmd = new SqlCommand();
        string query = "SELECT CityId, CityName FROM Cities WHERE CityName LIKE @Prefix + '%' AND StateId=@StateId";
        cmd.Parameters.AddWithValue("@Prefix", prefix);
        cmd.Parameters.AddWithValue("@StateId", parentId); cmd.CommandText = query;
        return PopulateAutoComplete(cmd);
    }

    private static string[] PopulateAutoComplete(SqlCommand cmd)
    {
        List<string> autocompleteItems = new List<string>();
        using (SqlConnection conn = new SqlConnection())
        {
            conn.ConnectionString = ConfigurationManager.ConnectionStrings["constr"].ConnectionString;
            cmd.Connection = conn;
            conn.Open();
            using (SqlDataReader sdr = cmd.ExecuteReader())
            {
                while (sdr.Read())
                {
                    autocompleteItems.Add(string.Format("{0}-{1}", sdr[1], sdr[0]));
                }
            }
            conn.Close();
        }
        return autocompleteItems.ToArray();
    }

    protected void Submit(object sender, EventArgs e)
    {
        string countryName = Request.Form[txtCountry.UniqueID];
        string countryId = Request.Form[hfCountry.UniqueID];

        string stateName = Request.Form[txtState.UniqueID];
        string stateId = Request.Form[hfState.UniqueID];

        string cityName = Request.Form[txtCity.UniqueID];
        string cityId = Request.Form[hfCity.UniqueID];

        string message = string.Format("Country: {0} {1}\\n", countryName, countryId);
        message += string.Format("State: {0} {1}\\n", stateName, stateId);
        message += string.Format("City: {0} {1}", cityName, cityId);
        ClientScript.RegisterStartupScript(this.GetType(), "alert", "alert('" + message + "');", true);
    }
}