﻿
Imports System.Web.Services
Imports System.Configuration
Imports System.Data.SqlClient

Partial Class VB
    Inherits System.Web.UI.Page

    <WebMethod()> _
    Public Shared Function GetCountries(prefix As String, parentId As Integer) As String()
        Dim cmd As New SqlCommand()
        Dim query As String = "SELECT CountryId, CountryName FROM Countries WHERE CountryName LIKE @Prefix + '%'"
        cmd.Parameters.AddWithValue("@Prefix", prefix)
        cmd.CommandText = query
        Return PopulateAutoComplete(cmd)
    End Function

    <WebMethod()> _
    Public Shared Function GetStates(prefix As String, parentId As Integer) As String()
        Dim cmd As New SqlCommand()
        Dim query As String = "SELECT StateId, StateName FROM States WHERE StateName LIKE @Prefix + '%' AND CountryId=@CountryId"
        cmd.Parameters.AddWithValue("@Prefix", prefix)
        cmd.Parameters.AddWithValue("@CountryId", parentId)
        cmd.CommandText = query
        Return PopulateAutoComplete(cmd)
    End Function

    <WebMethod()> _
    Public Shared Function GetCities(prefix As String, parentId As Integer) As String()
        Dim cmd As New SqlCommand()
        Dim query As String = "SELECT CityId, CityName FROM Cities WHERE CityName LIKE @Prefix + '%' AND StateId=@StateId"
        cmd.Parameters.AddWithValue("@Prefix", prefix)
        cmd.Parameters.AddWithValue("@StateId", parentId)
        cmd.CommandText = query
        Return PopulateAutoComplete(cmd)
    End Function

    Private Shared Function PopulateAutoComplete(cmd As SqlCommand) As String()
        Dim autocompleteItems As New List(Of String)()
        Using conn As New SqlConnection()
            conn.ConnectionString = ConfigurationManager.ConnectionStrings("constr").ConnectionString
            cmd.Connection = conn
            conn.Open()
            Using sdr As SqlDataReader = cmd.ExecuteReader()
                While sdr.Read()
                    autocompleteItems.Add(String.Format("{0}-{1}", sdr(1), sdr(0)))
                End While
            End Using
            conn.Close()
        End Using
        Return autocompleteItems.ToArray()
    End Function

    Protected Sub Submit(sender As Object, e As EventArgs)
        Dim countryName As String = Request.Form(txtCountry.UniqueID)
        Dim countryId As String = Request.Form(hfCountry.UniqueID)

        Dim stateName As String = Request.Form(txtState.UniqueID)
        Dim stateId As String = Request.Form(hfState.UniqueID)

        Dim cityName As String = Request.Form(txtCity.UniqueID)
        Dim cityId As String = Request.Form(hfCity.UniqueID)

        Dim message As String = String.Format("Country: {0} {1}\n", countryName, countryId)
        message += String.Format("State: {0} {1}\n", stateName, stateId)
        message += String.Format("City: {0} {1}", cityName, cityId)
        ClientScript.RegisterStartupScript(Me.GetType(), "alert", "alert('" & message + "');", True)
    End Sub
End Class

